Index: serefpolicy-contrib-20140730/sendmail.te
===================================================================
--- serefpolicy-contrib-20140730.orig/sendmail.te
+++ serefpolicy-contrib-20140730/sendmail.te
@@ -1,4 +1,4 @@
-policy_module(sendmail, 1.13.0)
+policy_module(sendmail, 1.12.1)
 
 ########################################
 #
@@ -37,21 +37,23 @@ role sendmail_unconfined_roles types unc
 
 ########################################
 #
-# Local policy
+# Sendmail local policy
 #
 
-allow sendmail_t self:capability { dac_override setuid setgid sys_nice chown sys_tty_config };
+allow sendmail_t self:capability { dac_override setuid setgid net_bind_service sys_nice chown sys_tty_config };
+dontaudit sendmail_t self:capability net_admin;
+dontaudit sendmail_t self:capability2 block_suspend;
 allow sendmail_t self:process { setsched setpgid setrlimit signal signull };
 allow sendmail_t self:fifo_file rw_fifo_file_perms;
-allow sendmail_t self:unix_stream_socket { accept listen };
-allow sendmail_t self:tcp_socket { accept listen };
+allow sendmail_t self:unix_stream_socket create_stream_socket_perms;
+allow sendmail_t self:unix_dgram_socket create_socket_perms;
+allow sendmail_t self:tcp_socket create_stream_socket_perms;
+allow sendmail_t self:udp_socket create_socket_perms;
 
+allow sendmail_t sendmail_log_t:dir setattr_dir_perms;
+manage_files_pattern(sendmail_t, sendmail_log_t, sendmail_log_t)
 allow sendmail_t sendmail_keytab_t:file read_file_perms;
 
-allow sendmail_t sendmail_log_t:dir setattr_dir_perms;
-append_files_pattern(sendmail_t, sendmail_log_t, sendmail_log_t)
-create_files_pattern(sendmail_t, sendmail_log_t, sendmail_log_t)
-setattr_files_pattern(sendmail_t, sendmail_log_t, sendmail_log_t)
 logging_log_filetrans(sendmail_t, sendmail_log_t, { file dir })
 
 manage_dirs_pattern(sendmail_t, sendmail_tmp_t, sendmail_tmp_t)
@@ -63,33 +65,21 @@ files_pid_filetrans(sendmail_t, sendmail
 
 kernel_read_network_state(sendmail_t)
 kernel_read_kernel_sysctls(sendmail_t)
+# for piping mail to a command
 kernel_read_system_state(sendmail_t)
 
-corenet_all_recvfrom_unlabeled(sendmail_t)
 corenet_all_recvfrom_netlabel(sendmail_t)
 corenet_tcp_sendrecv_generic_if(sendmail_t)
 corenet_tcp_sendrecv_generic_node(sendmail_t)
 corenet_tcp_sendrecv_all_ports(sendmail_t)
 corenet_tcp_bind_generic_node(sendmail_t)
-
-corenet_sendrecv_smtp_server_packets(sendmail_t)
 corenet_tcp_bind_smtp_port(sendmail_t)
-
-corenet_sendrecv_all_client_packets(sendmail_t)
 corenet_tcp_connect_all_ports(sendmail_t)
+corenet_sendrecv_smtp_server_packets(sendmail_t)
+corenet_sendrecv_smtp_client_packets(sendmail_t)
 
-corecmd_exec_bin(sendmail_t)
-corecmd_exec_shell(sendmail_t)
-
-dev_read_sysfs(sendmail_t)
 dev_read_urand(sendmail_t)
-
-domain_use_interactive_fds(sendmail_t)
-
-files_read_all_tmp_files(sendmail_t)
-files_read_etc_runtime_files(sendmail_t)
-files_read_usr_files(sendmail_t)
-files_search_spool(sendmail_t)
+dev_read_sysfs(sendmail_t)
 
 fs_getattr_all_fs(sendmail_t)
 fs_search_auto_mountpoints(sendmail_t)
@@ -98,35 +88,49 @@ fs_rw_anon_inodefs_files(sendmail_t)
 term_dontaudit_use_console(sendmail_t)
 term_dontaudit_use_generic_ptys(sendmail_t)
 
+# for piping mail to a command
+corecmd_exec_shell(sendmail_t)
+corecmd_exec_bin(sendmail_t)
+
+domain_use_interactive_fds(sendmail_t)
+
+files_search_spool(sendmail_t)
+# for piping mail to a command
+files_read_etc_runtime_files(sendmail_t)
+files_read_all_tmp_files(sendmail_t)
+
 init_use_fds(sendmail_t)
 init_use_script_ptys(sendmail_t)
+# sendmail wants to read /var/run/utmp if the controlling tty is /dev/console
 init_read_utmp(sendmail_t)
 init_dontaudit_write_utmp(sendmail_t)
 init_rw_script_tmp_files(sendmail_t)
 
 auth_use_nsswitch(sendmail_t)
 
+# Read /usr/lib/sasl2/.*
 libs_read_lib_files(sendmail_t)
 
 logging_send_syslog_msg(sendmail_t)
 logging_dontaudit_write_generic_logs(sendmail_t)
 
 miscfiles_read_generic_certs(sendmail_t)
-miscfiles_read_localization(sendmail_t)
 
 userdom_dontaudit_use_unpriv_user_fds(sendmail_t)
+userdom_read_user_home_content_files(sendmail_t)
+userdom_dontaudit_list_user_home_dirs(sendmail_t)
 
-mta_etc_filetrans_aliases(sendmail_t, file, "aliases")
-mta_etc_filetrans_aliases(sendmail_t, file, "aliases.db")
-mta_etc_filetrans_aliases(sendmail_t, file, "aliasesdb-stamp")
+mta_read_config(sendmail_t)
+mta_etc_filetrans_aliases(sendmail_t)
+# Write to /etc/aliases and /etc/mail.
 mta_manage_aliases(sendmail_t)
+# Write to /var/spool/mail and /var/spool/mqueue.
 mta_manage_queue(sendmail_t)
 mta_manage_spool(sendmail_t)
-mta_read_config(sendmail_t)
 mta_sendmail_exec(sendmail_t)
 
 optional_policy(`
-	cfengine_dontaudit_write_log_files(sendmail_t)
+	cfengine_dontaudit_write_log(sendmail_t)
 ')
 
 optional_policy(`
@@ -134,8 +138,8 @@ optional_policy(`
 ')
 
 optional_policy(`
-	clamav_search_lib(sendmail_t)
-	clamav_stream_connect(sendmail_t)
+	antivirus_search_db(sendmail_t)
+	antivirus_stream_connect(sendmail_t)
 ')
 
 optional_policy(`
@@ -164,6 +168,10 @@ optional_policy(`
 ')
 
 optional_policy(`
+	inn_write_inherited_news_lib(sendmail_t)
+')
+
+optional_policy(`
 	milter_stream_connect_all(sendmail_t)
 ')
 
@@ -172,6 +180,11 @@ optional_policy(`
 ')
 
 optional_policy(`
+	openshift_dontaudit_rw_inherited_fifo_files(sendmail_t)
+	openshift_rw_inherited_content(sendmail_t)
+')
+
+optional_policy(`
 	postfix_domtrans_postdrop(sendmail_t)
 	postfix_domtrans_master(sendmail_t)
 	postfix_domtrans_postqueue(sendmail_t)
@@ -193,6 +206,10 @@ optional_policy(`
 ')
 
 optional_policy(`
+	spamd_stream_connect(sendmail_t)
+')
+
+optional_policy(`
 	udev_read_db(sendmail_t)
 ')
 
@@ -206,8 +223,8 @@ optional_policy(`
 #
 
 optional_policy(`
-	mta_etc_filetrans_aliases(unconfined_sendmail_t, file, "aliases")
-	mta_etc_filetrans_aliases(unconfined_sendmail_t, file, "aliases.db")
-	mta_etc_filetrans_aliases(unconfined_sendmail_t, file, "aliasesdb-stamp")
-	unconfined_domain(unconfined_sendmail_t)
+    mta_etc_filetrans_aliases(unconfined_sendmail_t, "aliases")
+    mta_etc_filetrans_aliases(unconfined_sendmail_t, "aliases.db")
+    mta_etc_filetrans_aliases(unconfined_sendmail_t, "aliasesdb-stamp")
+    unconfined_domain(unconfined_sendmail_t)
 ')
Index: serefpolicy-contrib-20140730/sensord.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/sensord.fc
+++ serefpolicy-contrib-20140730/sensord.fc
@@ -1,5 +1,9 @@
+/lib/systemd/system/sensord.service		--	gen_context(system_u:object_r:sensord_unit_file_t,s0)
+
 /etc/rc\.d/init\.d/sensord	--	gen_context(system_u:object_r:sensord_initrc_exec_t,s0)
 
 /usr/sbin/sensord	--	gen_context(system_u:object_r:sensord_exec_t,s0)
 
+/var/log/sensor.*		gen_context(system_u:object_r:sensord_log_t,s0)
+
 /var/run/sensord\.pid	--	gen_context(system_u:object_r:sensord_var_run_t,s0)
Index: serefpolicy-contrib-20140730/sensord.if
===================================================================
--- serefpolicy-contrib-20140730.orig/sensord.if
+++ serefpolicy-contrib-20140730/sensord.if
@@ -1,35 +1,80 @@
-## <summary>Sensor information logging daemon.</summary>
+
+## <summary>Sensor information logging daemon</summary>
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an sensord environment.
+##	Execute sensord in the sensord domain.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`sensord_domtrans',`
+	gen_require(`
+		type sensord_t, sensord_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, sensord_exec_t, sensord_t)
+')
+########################################
+## <summary>
+##	Execute sensord server in the sensord domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain allowed to transition.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`sensord_systemctl',`
+	gen_require(`
+		type sensord_t;
+		type sensord_unit_file_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 sensord_unit_file_t:file read_file_perms;
+	allow $1 sensord_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, sensord_t)
+')
+
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an sensord environment
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`sensord_admin',`
 	gen_require(`
-		type sensord_t, sensord_initrc_exec_t, sensord_var_run_t;
+		type sensord_t;
+		type sensord_unit_file_t;
+		type sensord_log_t;
+		type sensord_var_run_t;
 	')
 
 	allow $1 sensord_t:process { ptrace signal_perms };
 	ps_process_pattern($1, sensord_t)
 
-	init_labeled_script_domtrans($1, sensord_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 sensord_initrc_exec_t system_r;
-	allow $2 system_r;
+	sensord_systemctl($1)
+	admin_pattern($1, sensord_unit_file_t)
+	allow $1 sensord_unit_file_t:service all_service_perms;
 
-	files_search_pids($1)
+	admin_pattern($1, sensord_log_t)
 	admin_pattern($1, sensord_var_run_t)
+
+	optional_policy(`
+		systemd_passwd_agent_exec($1)
+		systemd_read_fifo_file_passwd_run($1)
+	')
 ')
Index: serefpolicy-contrib-20140730/sensord.te
===================================================================
--- serefpolicy-contrib-20140730.orig/sensord.te
+++ serefpolicy-contrib-20140730/sensord.te
@@ -9,12 +9,18 @@ type sensord_t;
 type sensord_exec_t;
 init_daemon_domain(sensord_t, sensord_exec_t)
 
+type sensord_unit_file_t;
+systemd_unit_file(sensord_unit_file_t)
+
 type sensord_initrc_exec_t;
 init_script_file(sensord_initrc_exec_t)
 
 type sensord_var_run_t;
 files_pid_file(sensord_var_run_t)
 
+type sensord_log_t;
+logging_log_file(sensord_log_t)
+
 ########################################
 #
 # Local policy
@@ -23,13 +29,13 @@ files_pid_file(sensord_var_run_t)
 allow sensord_t self:fifo_file rw_fifo_file_perms;
 allow sensord_t self:unix_stream_socket create_stream_socket_perms;
 
+manage_files_pattern(sensord_t, sensord_log_t, sensord_log_t)
+logging_log_filetrans(sensord_t, sensord_log_t, file)
+
 manage_files_pattern(sensord_t, sensord_var_run_t, sensord_var_run_t)
 files_pid_filetrans(sensord_t, sensord_var_run_t, file)
 
 dev_read_sysfs(sensord_t)
 
-files_read_etc_files(sensord_t)
-
 logging_send_syslog_msg(sensord_t)
 
-miscfiles_read_localization(sensord_t)
Index: serefpolicy-contrib-20140730/setroubleshoot.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/setroubleshoot.fc
+++ serefpolicy-contrib-20140730/setroubleshoot.fc
@@ -1,9 +1,9 @@
 /usr/sbin/setroubleshootd	--	gen_context(system_u:object_r:setroubleshootd_exec_t,s0)
 
-/usr/share/setroubleshoot/SetroubleshootFixit\.py	--	gen_context(system_u:object_r:setroubleshoot_fixit_exec_t,s0)
+/usr/share/setroubleshoot/SetroubleshootFixit\.py* -- gen_context(system_u:object_r:setroubleshoot_fixit_exec_t,s0)
 
-/var/run/setroubleshoot(/.*)?	gen_context(system_u:object_r:setroubleshoot_var_run_t,s0)
+/var/run/setroubleshoot(/.*)?		gen_context(system_u:object_r:setroubleshoot_var_run_t,s0)
 
-/var/log/setroubleshoot(/.*)?	gen_context(system_u:object_r:setroubleshoot_var_log_t,s0)
+/var/log/setroubleshoot(/.*)?		gen_context(system_u:object_r:setroubleshoot_var_log_t,s0)
 
-/var/lib/setroubleshoot(/.*)?	gen_context(system_u:object_r:setroubleshoot_var_lib_t,s0)
+/var/lib/setroubleshoot(/.*)?		gen_context(system_u:object_r:setroubleshoot_var_lib_t,s0)
Index: serefpolicy-contrib-20140730/setroubleshoot.if
===================================================================
--- serefpolicy-contrib-20140730.orig/setroubleshoot.if
+++ serefpolicy-contrib-20140730/setroubleshoot.if
@@ -1,9 +1,8 @@
-## <summary>SELinux troubleshooting service.</summary>
+## <summary>SELinux troubleshooting service</summary>
 
 ########################################
 ## <summary>
-##	Connect to setroubleshootd with a
-##	unix domain stream socket.
+##	Connect to setroubleshootd over a unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -23,9 +22,8 @@ interface(`setroubleshoot_stream_connect
 
 ########################################
 ## <summary>
-##	Do not audit attempts to connect to
-##	setroubleshootd with a unix
-##	domain stream socket.
+##	Dontaudit attempts to connect to setroubleshootd
+##	over a unix stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -125,8 +123,27 @@ interface(`setroubleshoot_dbus_chat_fixi
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an setroubleshoot environment.
+##	Dontaudit read/write to a setroubleshoot leaked sockets.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain to not audit.
+##	</summary>
+## </param>
+#
+interface(`setroubleshoot_fixit_dontaudit_leaks',`
+	gen_require(`
+		type setroubleshoot_fixit_t;
+	')
+
+	dontaudit $1 setroubleshoot_fixit_t:unix_dgram_socket { read write };
+	dontaudit $1 setroubleshoot_fixit_t:unix_stream_socket { read write };
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an setroubleshoot environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -137,12 +154,15 @@ interface(`setroubleshoot_dbus_chat_fixi
 #
 interface(`setroubleshoot_admin',`
 	gen_require(`
-		type setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_fixit_t;
-		type setroubleshoot_var_lib_t, setroubleshoot_var_run_t;
+		type setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_var_run_t;
+		type setroubleshoot_var_lib_t;
 	')
 
-	allow $1 { setroubleshoot_fixit_t setroubleshootd_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { setroubleshootd_t setroubleshoot_fixit_t })
+	allow $1 setroubleshootd_t:process signal_perms;
+	ps_process_pattern($1, setroubleshootd_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 setroubleshootd_t:process ptrace;
+	')
 
 	logging_list_logs($1)
 	admin_pattern($1, setroubleshoot_var_log_t)
Index: serefpolicy-contrib-20140730/setroubleshoot.te
===================================================================
--- serefpolicy-contrib-20140730.orig/setroubleshoot.te
+++ serefpolicy-contrib-20140730/setroubleshoot.te
@@ -1,4 +1,4 @@
-policy_module(setroubleshoot, 1.13.1)
+policy_module(setroubleshoot, 1.12.1)
 
 ########################################
 #
@@ -7,43 +7,52 @@ policy_module(setroubleshoot, 1.13.1)
 
 type setroubleshootd_t alias setroubleshoot_t;
 type setroubleshootd_exec_t;
-init_system_domain(setroubleshootd_t, setroubleshootd_exec_t)
+domain_type(setroubleshootd_t)
+init_daemon_domain(setroubleshootd_t, setroubleshootd_exec_t)
 
 type setroubleshoot_fixit_t;
 type setroubleshoot_fixit_exec_t;
-init_system_domain(setroubleshoot_fixit_t, setroubleshoot_fixit_exec_t)
+init_daemon_domain(setroubleshoot_fixit_t, setroubleshoot_fixit_exec_t)
 
 type setroubleshoot_var_lib_t;
 files_type(setroubleshoot_var_lib_t)
 
+# log files
 type setroubleshoot_var_log_t;
 logging_log_file(setroubleshoot_var_log_t)
 
+# pid files
 type setroubleshoot_var_run_t;
 files_pid_file(setroubleshoot_var_run_t)
 
 ########################################
 #
-# Local policy
+# setroubleshootd local policy
 #
 
 allow setroubleshootd_t self:capability { dac_override sys_nice sys_ptrace sys_tty_config };
-allow setroubleshootd_t self:process { getattr getsched setsched sigkill signull signal execmem execstack };
+dontaudit setroubleshootd_t self:capability net_admin;
+
+allow setroubleshootd_t self:process { getattr getsched setsched sigkill signull signal };
+# if bad library causes setroubleshoot to require these, we want to give it so setroubleshoot can continue to run
+allow setroubleshootd_t self:process { execmem execstack };
 allow setroubleshootd_t self:fifo_file rw_fifo_file_perms;
-allow setroubleshootd_t self:tcp_socket { accept listen };
-allow setroubleshootd_t self:unix_stream_socket { accept connectto listen };
+allow setroubleshootd_t self:tcp_socket create_stream_socket_perms;
+allow setroubleshootd_t self:unix_stream_socket { create_stream_socket_perms connectto };
+allow setroubleshootd_t self:unix_dgram_socket create_socket_perms;
 
-allow setroubleshootd_t setroubleshoot_var_lib_t:dir setattr_dir_perms;
+# database files
+allow setroubleshootd_t setroubleshoot_var_lib_t:dir setattr;
 manage_files_pattern(setroubleshootd_t, setroubleshoot_var_lib_t, setroubleshoot_var_lib_t)
 files_var_lib_filetrans(setroubleshootd_t, setroubleshoot_var_lib_t, { file dir })
 
-allow setroubleshootd_t setroubleshoot_var_log_t:dir setattr_dir_perms;
-append_files_pattern(setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_var_log_t)
-create_files_pattern(setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_var_log_t)
-setattr_files_pattern(setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_var_log_t)
+# log files
+allow setroubleshootd_t setroubleshoot_var_log_t:dir setattr;
+manage_files_pattern(setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_var_log_t)
 manage_sock_files_pattern(setroubleshootd_t, setroubleshoot_var_log_t, setroubleshoot_var_log_t)
 logging_log_filetrans(setroubleshootd_t, setroubleshoot_var_log_t, { file dir })
 
+# pid file
 manage_dirs_pattern(setroubleshootd_t, setroubleshoot_var_run_t, setroubleshoot_var_run_t)
 manage_files_pattern(setroubleshootd_t, setroubleshoot_var_run_t, setroubleshoot_var_run_t)
 manage_sock_files_pattern(setroubleshootd_t, setroubleshoot_var_run_t, setroubleshoot_var_run_t)
@@ -55,20 +64,20 @@ kernel_read_net_sysctls(setroubleshootd_
 kernel_read_network_state(setroubleshootd_t)
 kernel_dontaudit_list_all_proc(setroubleshootd_t)
 kernel_read_irq_sysctls(setroubleshootd_t)
+kernel_read_rpc_sysctls(setroubleshootd_t)
 kernel_read_unlabeled_state(setroubleshootd_t)
 
 corecmd_exec_bin(setroubleshootd_t)
 corecmd_exec_shell(setroubleshootd_t)
 corecmd_read_all_executables(setroubleshootd_t)
 
-corenet_all_recvfrom_unlabeled(setroubleshootd_t)
 corenet_all_recvfrom_netlabel(setroubleshootd_t)
 corenet_tcp_sendrecv_generic_if(setroubleshootd_t)
 corenet_tcp_sendrecv_generic_node(setroubleshootd_t)
-
-corenet_sendrecv_smtp_client_packets(setroubleshootd_t)
+corenet_tcp_sendrecv_all_ports(setroubleshootd_t)
+corenet_tcp_bind_generic_node(setroubleshootd_t)
 corenet_tcp_connect_smtp_port(setroubleshootd_t)
-corenet_tcp_sendrecv_smtp_port(setroubleshootd_t)
+corenet_sendrecv_smtp_client_packets(setroubleshootd_t)
 
 dev_read_urand(setroubleshootd_t)
 dev_read_sysfs(setroubleshootd_t)
@@ -76,10 +85,9 @@ dev_getattr_all_blk_files(setroubleshoot
 dev_getattr_all_chr_files(setroubleshootd_t)
 dev_getattr_mtrr_dev(setroubleshootd_t)
 
-domain_dontaudit_search_all_domains_state(setroubleshootd_t)
+domain_read_all_domains_state(setroubleshootd_t)
 domain_signull_all_domains(setroubleshootd_t)
 
-files_read_usr_files(setroubleshootd_t)
 files_list_all(setroubleshootd_t)
 files_getattr_all_files(setroubleshootd_t)
 files_getattr_all_pipes(setroubleshootd_t)
@@ -109,27 +117,24 @@ init_read_utmp(setroubleshootd_t)
 init_dontaudit_write_utmp(setroubleshootd_t)
 
 libs_exec_ld_so(setroubleshootd_t)
+libs_exec_ldconfig(setroubleshootd_t)
 
 locallogin_dontaudit_use_fds(setroubleshootd_t)
 
 logging_send_audit_msgs(setroubleshootd_t)
 logging_send_syslog_msg(setroubleshootd_t)
 logging_stream_connect_dispatcher(setroubleshootd_t)
+logging_stream_connect_syslog(setroubleshootd_t)
 
-miscfiles_read_localization(setroubleshootd_t)
-
+seutil_read_bin_policy(setroubleshootd_t)
 seutil_read_config(setroubleshootd_t)
+seutil_read_default_contexts(setroubleshootd_t)
 seutil_read_file_contexts(setroubleshootd_t)
-seutil_read_bin_policy(setroubleshootd_t)
 
 userdom_dontaudit_read_user_home_content_files(setroubleshootd_t)
 
 optional_policy(`
-	dbus_system_domain(setroubleshootd_t, setroubleshootd_exec_t)
-
-	optional_policy(`
-		abrt_dbus_chat(setroubleshootd_t)
-	')
+	abrt_dbus_chat(setroubleshootd_t)
 ')
 
 optional_policy(`
@@ -137,10 +142,18 @@ optional_policy(`
 ')
 
 optional_policy(`
+	mock_getattr_lib(setroubleshootd_t)
+')
+
+optional_policy(`
 	modutils_read_module_config(setroubleshootd_t)
 ')
 
 optional_policy(`
+	dbus_system_domain(setroubleshootd_t, setroubleshootd_exec_t)
+')
+
+optional_policy(`
 	rpm_exec(setroubleshootd_t)
 	rpm_signull(setroubleshootd_t)
 	rpm_read_db(setroubleshootd_t)
@@ -150,26 +163,36 @@ optional_policy(`
 
 ########################################
 #
-# Fixit local policy
+# setroubleshoot_fixit local policy
 #
 
 allow setroubleshoot_fixit_t self:capability sys_nice;
 allow setroubleshoot_fixit_t self:process { setsched getsched };
+dontaudit setroubleshoot_fixit_t self:process execmem;
 allow setroubleshoot_fixit_t self:fifo_file rw_fifo_file_perms;
+allow setroubleshoot_fixit_t self:unix_dgram_socket create_socket_perms;
 
 allow setroubleshoot_fixit_t setroubleshootd_t:process signull;
 
+setroubleshoot_dbus_chat(setroubleshoot_fixit_t)
 setroubleshoot_stream_connect(setroubleshoot_fixit_t)
 
 kernel_read_system_state(setroubleshoot_fixit_t)
+kernel_read_network_state(setroubleshoot_fixit_t)
 
 corecmd_exec_bin(setroubleshoot_fixit_t)
 corecmd_exec_shell(setroubleshoot_fixit_t)
 corecmd_getattr_all_executables(setroubleshoot_fixit_t)
 
+dev_read_sysfs(setroubleshoot_fixit_t)
+dev_read_urand(setroubleshoot_fixit_t)
+
+selinux_read_policy(setroubleshoot_fixit_t)
+
 seutil_domtrans_setfiles(setroubleshoot_fixit_t)
+seutil_domtrans_setsebool(setroubleshoot_fixit_t)
+seutil_read_module_store(setroubleshoot_fixit_t)
 
-files_read_usr_files(setroubleshoot_fixit_t)
 files_list_tmp(setroubleshoot_fixit_t)
 
 auth_use_nsswitch(setroubleshoot_fixit_t)
@@ -177,23 +200,26 @@ auth_use_nsswitch(setroubleshoot_fixit_t
 logging_send_audit_msgs(setroubleshoot_fixit_t)
 logging_send_syslog_msg(setroubleshoot_fixit_t)
 
-miscfiles_read_localization(setroubleshoot_fixit_t)
-
-userdom_read_all_users_state(setroubleshoot_fixit_t)
+userdom_dontaudit_search_admin_dir(setroubleshoot_fixit_t)
 userdom_signull_unpriv_users(setroubleshoot_fixit_t)
 
 optional_policy(`
 	dbus_system_domain(setroubleshoot_fixit_t, setroubleshoot_fixit_exec_t)
-	setroubleshoot_dbus_chat(setroubleshoot_fixit_t)
+')
 
-	optional_policy(`
-		policykit_dbus_chat(setroubleshoot_fixit_t)
-	')
+optional_policy(`
+	gnome_dontaudit_search_config(setroubleshoot_fixit_t)
 ')
 
 optional_policy(`
+	rpm_exec(setroubleshoot_fixit_t)
 	rpm_signull(setroubleshoot_fixit_t)
 	rpm_read_db(setroubleshoot_fixit_t)
 	rpm_dontaudit_manage_db(setroubleshoot_fixit_t)
 	rpm_use_script_fds(setroubleshoot_fixit_t)
 ')
+
+optional_policy(`
+	policykit_dbus_chat(setroubleshoot_fixit_t)
+	userdom_read_all_users_state(setroubleshoot_fixit_t)
+')
Index: serefpolicy-contrib-20140730/sge.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/sge.fc
@@ -0,0 +1,6 @@
+
+/usr/bin/sge_execd	--	gen_context(system_u:object_r:sge_execd_exec_t,s0)
+/usr/bin/sge_shepherd  --  gen_context(system_u:object_r:sge_shepherd_exec_t,s0)
+
+/var/spool/gridengine(/.*)?       gen_context(system_u:object_r:sge_spool_t,s0)
+
Index: serefpolicy-contrib-20140730/sge.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/sge.if
@@ -0,0 +1,24 @@
+## <summary>Policy for gridengine MPI jobs</summary>
+
+######################################
+## <summary>
+##  Creates types and rules for a basic
+##  sge domain.
+## </summary>
+## <param name="prefix">
+##  <summary>
+##  Prefix for the domain.
+##  </summary>
+## </param>
+#
+template(`sge_basic_types_template',`
+    gen_require(`
+        attribute sge_domain;
+    ')
+
+    type $1_t, sge_domain;
+    type $1_exec_t;
+
+	kernel_read_system_state($1_t)
+')
+
Index: serefpolicy-contrib-20140730/sge.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/sge.te
@@ -0,0 +1,195 @@
+policy_module(sge, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+## <desc>
+## <p>
+## Allow sge to access nfs file systems.
+## </p>
+## </desc>
+gen_tunable(sge_use_nfs, false)
+
+## <desc>
+## <p>
+## Allow sge to connect to the network using any TCP port
+## </p>
+## </desc>
+gen_tunable(sge_domain_can_network_connect, false)
+
+attribute sge_domain;
+
+sge_basic_types_template(sge_execd)
+init_daemon_domain(sge_execd_t, sge_execd_exec_t)
+
+type sge_spool_t;
+files_type(sge_spool_t)
+
+type sge_tmp_t;
+files_tmp_file(sge_tmp_t)
+
+sge_basic_types_template(sge_shepherd)
+application_domain(sge_shepherd_t, sge_shepherd_exec_t)
+role system_r types sge_shepherd_t;
+
+sge_basic_types_template(sge_job)
+application_domain(sge_job_t, sge_job_exec_t)
+corecmd_shell_entry_type(sge_job_t)
+role system_r types sge_job_t;
+
+#######################################
+#
+# sge_execd local policy
+#
+
+allow sge_execd_t self:capability { dac_override kill setuid chown setgid };
+allow sge_execd_t self:process { setsched signal setpgid };
+
+allow sge_execd_t sge_shepherd_t:process signal;
+
+kernel_read_kernel_sysctls(sge_execd_t)
+
+corenet_tcp_bind_sge_port(sge_execd_t)
+corenet_tcp_connect_sge_port(sge_execd_t)
+
+dev_read_sysfs(sge_execd_t)
+
+files_exec_usr_files(sge_execd_t)
+files_search_spool(sge_execd_t)
+
+fs_getattr_xattr_fs(sge_execd_t)
+fs_read_cgroup_files(sge_execd_t)
+
+auth_use_nsswitch(sge_execd_t)
+
+logging_send_syslog_msg(sge_execd_t)
+
+init_read_utmp(sge_execd_t)
+
+optional_policy(`
+	sendmail_domtrans(sge_execd_t)
+')
+
+######################################
+#
+# sge_shepherd local policy
+#
+
+allow sge_shepherd_t self:capability { setuid sys_nice chown kill setgid dac_override };
+allow sge_shepherd_t self:process { setsched setrlimit setpgid };
+allow sge_shepherd_t self:process signal_perms;
+
+domtrans_pattern(sge_execd_t, sge_shepherd_exec_t, sge_shepherd_t)
+
+kernel_read_sysctl(sge_shepherd_t)
+kernel_read_kernel_sysctls(sge_shepherd_t)
+
+dev_read_sysfs(sge_shepherd_t)
+
+fs_getattr_all_fs(sge_shepherd_t)
+
+logging_send_syslog_msg(sge_shepherd_t)
+
+optional_policy(`
+	mta_send_mail(sge_shepherd_t)
+')
+
+optional_policy(`
+	ssh_domtrans(sge_shepherd_t)
+')
+
+optional_policy(`
+	unconfined_domain(sge_shepherd_t)
+')
+
+#####################################
+#
+# sge_job local policy
+#
+
+allow sge_shepherd_t sge_job_t:process signal_perms;
+
+corecmd_shell_domtrans(sge_shepherd_t, sge_job_t)
+
+kernel_read_kernel_sysctls(sge_job_t)
+
+term_use_all_terms(sge_job_t)
+
+logging_send_syslog_msg(sge_job_t)
+
+optional_policy(`
+	ssh_basic_client_template(sge_job, sge_job_t, system_r)
+	ssh_domtrans(sge_job_t)
+
+	allow sge_job_t sge_job_ssh_t:process sigkill;
+	allow sge_shepherd_t sge_job_ssh_t:process sigkill;
+
+	xserver_exec_xauth(sge_job_ssh_t)
+
+        tunable_policy(`sge_use_nfs',`
+            fs_list_auto_mountpoints(sge_job_ssh_t)
+            fs_manage_nfs_dirs(sge_job_ssh_t)
+            fs_manage_nfs_files(sge_job_ssh_t)
+            fs_read_nfs_symlinks(sge_job_ssh_t)
+        ')
+	')
+
+optional_policy(`
+	xserver_domtrans_xauth(sge_job_t)
+')
+
+optional_policy(`
+	unconfined_domain(sge_job_t)
+')
+
+#####################################
+#
+# sge_domain local policy
+#
+
+allow sge_domain self:fifo_file rw_fifo_file_perms;
+allow sge_domain self:tcp_socket create_stream_socket_perms;
+
+manage_dirs_pattern(sge_domain, sge_spool_t, sge_spool_t)
+manage_files_pattern(sge_domain, sge_spool_t, sge_spool_t)
+manage_lnk_files_pattern(sge_domain, sge_spool_t, sge_spool_t)
+
+manage_files_pattern(sge_domain, sge_tmp_t, sge_tmp_t)
+manage_dirs_pattern(sge_domain, sge_tmp_t, sge_tmp_t)
+files_tmp_filetrans(sge_domain, sge_tmp_t, { file dir })
+
+kernel_read_network_state(sge_domain)
+
+corecmd_exec_bin(sge_domain)
+corecmd_exec_shell(sge_domain)
+
+domain_read_all_domains_state(sge_domain)
+
+
+dev_read_urand(sge_domain)
+
+tunable_policy(`sge_domain_can_network_connect',`
+    corenet_tcp_connect_all_ports(sge_domain)
+')
+
+tunable_policy(`sge_use_nfs',`
+    fs_list_auto_mountpoints(sge_domain)
+	fs_manage_nfs_dirs(sge_domain)
+	fs_manage_nfs_files(sge_domain)
+	fs_read_nfs_symlinks(sge_domain)
+	fs_exec_nfs_files(sge_domain)
+')
+
+optional_policy(`
+	sysnet_dns_name_resolve(sge_domain)
+')
+
+optional_policy(`
+    hostname_exec(sge_domain)
+')
+
+optional_policy(`
+	nslcd_stream_connect(sge_domain)
+')
